/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package tp2;

import java.io.Serializable;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

/**
 *
 * @author MIAGE
 */
@Entity(name="CompteEpargne")
@DiscriminatorValue("CompteEpargne")
public class CompteEpargne extends CompteBancaire implements Serializable {
    private static final long serialVersionUID = 1L;
    private float tauxInteret;

    public CompteEpargne(Proprietaire proprietaire, int solde, float tauxInteret) {
        super(proprietaire, solde);
        this.tauxInteret = tauxInteret;
    }

    public CompteEpargne() {
    }

    public float getTauxInteret() {
        return tauxInteret;
    }

    public void setTauxInteret(float tauxInteret) {
        this.tauxInteret = tauxInteret;
    }

    @Override
    public int getId() {
        return id;
    }

    @Override
    public void setId(int id) {
        this.id = id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (int) id;
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof CompteEpargne)) {
            return false;
        }
        CompteEpargne other = (CompteEpargne) object;
        if (this.id != other.id) {
            return false;
        }
        return true;
    }
    @Override
        public Proprietaire getProprietaire() {
        return proprietaire;
    }

    @Override
    public void setProprietaire(Proprietaire proprietaire) {
        this.proprietaire = proprietaire;
    }

    @Override
    public String toString() {
        return "tp2.NewEntity[id=" + id + "]";
    }

}
