/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package tp2;

import java.util.ArrayList;
import java.util.Collection;
import javax.ejb.Stateless;
import javax.persistence.Query;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 *
 * @author Pierrick
 */
@Stateless
public class GestionnaireDeCompteBancaire implements GestionnaireDeCompteBancaireLocal {

    // Add business logic below. (Right-click in editor and choose
    // "Insert Code > Add Business Method")
    @PersistenceContext
    private EntityManager em;
    private Collection<CompteBancaire> compteBancaire;
    private Collection<Proprietaire> proprietaire;
    private Collection<OperationBancaire> operationBancaire;

    @Override
    public void creerComptesTest() {

        // Création des collections d'opérations
        Collection<OperationBancaire> colOpe1 = new ArrayList();
        Collection<OperationBancaire> colOpe2 = new ArrayList();
        Collection<OperationBancaire> colOpe3 = new ArrayList();
        Collection<OperationBancaire> colOpe4 = new ArrayList();
        Collection<OperationBancaire> colOpe5 = new ArrayList();
        Collection<OperationBancaire> colOpe6 = new ArrayList();
        Collection<OperationBancaire> colOpe7 = new ArrayList();
        Collection<OperationBancaire> colOpe8 = new ArrayList();
        Collection<OperationBancaire> colOpe9 = new ArrayList();
        Collection<OperationBancaire> colOpe10 = new ArrayList();

        // Création des opérations de crédit
        OperationBancaire opc1 = new OperationBancaire("Crédit", 10450);
        OperationBancaire opc2 = new OperationBancaire("Crédit", 80);
        OperationBancaire opc3 = new OperationBancaire("Crédit", 987);
        OperationBancaire opc4 = new OperationBancaire("Crédit", 12);
        OperationBancaire opc5 = new OperationBancaire("Crédit", 56);
        OperationBancaire opc6 = new OperationBancaire("Crédit", 765);
        OperationBancaire opc7 = new OperationBancaire("Crédit", 345);
        OperationBancaire opc8 = new OperationBancaire("Crédit", 5678);
        OperationBancaire opc9 = new OperationBancaire("Crédit", 9876);
        OperationBancaire opc10 = new OperationBancaire("Crédit", 6854);
        OperationBancaire opc11 = new OperationBancaire("Crédit", 3443);
        OperationBancaire opc12 = new OperationBancaire("Crédit", 767);
        OperationBancaire opc13 = new OperationBancaire("Crédit", 454);
        OperationBancaire opc14 = new OperationBancaire("Crédit", 989);
        OperationBancaire opc15 = new OperationBancaire("Crédit", 121);
        OperationBancaire opc16 = new OperationBancaire("Crédit", 777);
        OperationBancaire opc17 = new OperationBancaire("Crédit", 3678);
        OperationBancaire opc18 = new OperationBancaire("Crédit", 779);
        OperationBancaire opc19 = new OperationBancaire("Crédit", 5098);
        OperationBancaire opc20 = new OperationBancaire("Crédit", 67);

        // Création des opérations de débit
        OperationBancaire opd1 = new OperationBancaire("Débit", -45);
        OperationBancaire opd2 = new OperationBancaire("Débit", -34);
        OperationBancaire opd3 = new OperationBancaire("Débit", -87);
        OperationBancaire opd4 = new OperationBancaire("Débit", -98);
        OperationBancaire opd5 = new OperationBancaire("Débit", -976);
        OperationBancaire opd6 = new OperationBancaire("Débit", -654);
        OperationBancaire opd7 = new OperationBancaire("Débit", -32);
        OperationBancaire opd8 = new OperationBancaire("Débit", -321);
        OperationBancaire opd9 = new OperationBancaire("Débit", -765);
        OperationBancaire opd10 = new OperationBancaire("Débit", -653);
        OperationBancaire opd11 = new OperationBancaire("Débit", -767);
        OperationBancaire opd12 = new OperationBancaire("Débit", -97);
        OperationBancaire opd13 = new OperationBancaire("Débit", -55);
        OperationBancaire opd14 = new OperationBancaire("Débit", -6);
        OperationBancaire opd15 = new OperationBancaire("Débit", -844);
        OperationBancaire opd16 = new OperationBancaire("Débit", -674);
        OperationBancaire opd17 = new OperationBancaire("Débit", -63);
        OperationBancaire opd18 = new OperationBancaire("Débit", -74);
        OperationBancaire opd19 = new OperationBancaire("Débit", -67);
        OperationBancaire opd20 = new OperationBancaire("Débit", -4);

        // Operations du compte bancaire 1
        colOpe1.add(opc1);
        colOpe1.add(opc2);
        colOpe1.add(opd1);
        colOpe1.add(opc3);

        // Operations du compte bancaire 2
        colOpe2.add(opc4);
        colOpe2.add(opd2);
        colOpe2.add(opd3);
        colOpe2.add(opc5);

        // Operations du compte bancaire 3
        colOpe3.add(opc6);
        colOpe3.add(opd4);
        colOpe3.add(opc7);
        colOpe3.add(opc8);

        // Operations du compte bancaire 4
        colOpe4.add(opc9);
        colOpe4.add(opd5);
        colOpe4.add(opd6);
        colOpe4.add(opd7);

        // Operations du compte bancaire 5
        colOpe5.add(opd8);
        colOpe5.add(opc10);
        colOpe5.add(opd9);
        colOpe5.add(opd10);

        // Operations du compte bancaire 6
        colOpe6.add(opd11);
        colOpe6.add(opd12);
        colOpe6.add(opc11);
        colOpe6.add(opc12);

        // Operations du compte bancaire 7
        colOpe7.add(opd13);
        colOpe7.add(opc13);
        colOpe7.add(opd14);
        colOpe7.add(opd15);

        // Operations du compte bancaire 8
        colOpe8.add(opc14);
        colOpe8.add(opc15);
        colOpe8.add(opc16);
        colOpe8.add(opd16);

        // Operations du compte bancaire 9
        colOpe9.add(opd17);
        colOpe9.add(opc17);
        colOpe9.add(opd18);
        colOpe9.add(opd19);

        // Operations du compte bancaire 10
        colOpe10.add(opc18);
        colOpe10.add(opc19);
        colOpe10.add(opc20);
        colOpe10.add(opd20);

        //Création des propriétaires
        Proprietaire p1 = CreerProprietaire("Lenon", "John", "4 cimetière du père fouras Londres", "0623424312");
        Proprietaire p2 = CreerProprietaire("Mc Cartney", "Paul", "3 chemin du thé, Liverpool", "0623432312");
        Proprietaire p3 = CreerProprietaire("Harrisson", "Georges", "5 cimetière du père fouras Londres", "0623431312");
        Proprietaire p4 = CreerProprietaire("Star", "Ringo", "5 rue pieton, londres", "0633432312");
        Proprietaire p5 = CreerProprietaire("Kaka", "Grégoire", "5 chemin du grand pieton, nice", "0632332312");
        Proprietaire p6 = CreerProprietaire("Gattuso", "Pierrick", "2 village perché, la bas", "0633432352");
        Proprietaire p7 = CreerProprietaire("Furtado", "Eddy", "près de chez oliv", "0653432312");
        Proprietaire p8 = CreerProprietaire("Linux", "Olivier", "près de chez eddy", "0633262312");

        // Création des comptes bancaires
        creerCompte(p1.getId(), 2000, colOpe1);
        creerCompte(p2.getId(), 3000, colOpe2);
        creerCompte(p3.getId(), 500, colOpe3);
        creerCompte(p4.getId(), 2000, colOpe4);
        creerCompte(p5.getId(), 45000, colOpe5);
        creerCompte(p6.getId(), 67000, colOpe6);
        creerCompte(p7.getId(), 1000, colOpe7);
        creerCompte(p8.getId(), 100, colOpe8);

        //Création de comptes épargnes 1-n
        creerCompte(p1.getId(), 400, colOpe9, 0.03f);
        creerCompte(p2.getId(), 5000, colOpe10, 0.02f);
    }

    @Override
    public CompteBancaire creerCompte(int idProprietaire, int m, Collection<OperationBancaire> colOpe) {
        // Si on ne fait pas cela, le client n'est pas connecté à la BD, mais en fait, 
        // On fait mieux de passer l'id et de chercher le proprio ici, cela sera dans
        // la meme transaction.
        //em.merge(p);
        Proprietaire p = getProprietaire(idProprietaire);
        // On crée le compte et on met à jour la relation bi-directionelle
        // client-comptes. Note : on persiste le compte de suite, comme cela
        // On a à la fois le compte et le client de connectés
        CompteBancaire c = new CompteBancaire(p, m);
        p.getListeComptes().add(c);
        em.persist(c);


        OperationBancaire op = new OperationBancaire("Création du compte bancaire", m);
        c.getOperations().add(op);
        if (colOpe != null) {
            for (OperationBancaire o : colOpe) {
                c.getOperations().add(o);
                c.deposer(o.getMontant());
            }
        }

        return c;
    }

    @Override
    public CompteBancaire creerCompte(int idProprietaire, int m, Collection<OperationBancaire> colOpe, float tauxInteret) {
        //em.merge(p);
        Proprietaire p = getProprietaire(idProprietaire);
        CompteEpargne c = new CompteEpargne(p, m, tauxInteret);
        p.getListeComptes().add(c);

        em.persist(c);

        OperationBancaire op = new OperationBancaire("Création du compte épargne", m);
        c.getOperations().add(op);

        if (colOpe != null) {
            for (OperationBancaire o : colOpe) {
                c.getOperations().add(o);
                c.deposer(o.getMontant());
            }
        }


        return c;
    }

    public OperationBancaire creerOperationBancaire(String p, int m) {
        OperationBancaire op = new OperationBancaire(p, m);
        em.persist(op);
        return op;
    }

    @Override
    public Collection<CompteBancaire> afficherTout() {
        Query q = em.createQuery("select b FROM CompteBancaire b order by b.id asc");
        compteBancaire = q.getResultList();
        return compteBancaire;
    }

    @Override
    public void transfererArgent(int id1, int id2, int montant) {
        if ((getCompte(id1)).retirer(montant) != 0) {
            // retrait sur le compte du donneur
            OperationBancaire opD = new OperationBancaire("Débit", -montant);
            (getCompte(id1)).getOperations().add(opD);

            // ajout sur le compte du receveur
            (getCompte(id2)).deposer(montant);
            OperationBancaire opC = new OperationBancaire("Crédit", montant);
            (getCompte(id2)).getOperations().add(opC);

        }
    }

    @Override
    public Collection<OperationBancaire> afficherOpe(int id) {
        Query q = em.createQuery("select cpt.operations from CompteBancaire cpt where cpt.id=:id");
        q.setParameter("id", id);
        operationBancaire = q.getResultList();
        return operationBancaire;
    }

    @Override
    public CompteBancaire getCompte(int id) {
        return (em.find(CompteBancaire.class, id));
    }

    @Override
    public Collection<Proprietaire> afficherProprietaires() {
        Query q = em.createQuery("select b FROM Proprietaire b order by b.id asc");
        proprietaire = q.getResultList();
        return proprietaire;
    }

    @Override
    public Proprietaire getProprietaire(int id) {
        return (em.find(Proprietaire.class, id));
    }

    @Override
    public Proprietaire CreerProprietaire(String nom, String prenom, String adresse, String telephone) {
        Proprietaire p = new Proprietaire(nom, prenom, adresse, telephone);
        em.persist(p);
        return p;
    }
}
