/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package tp2;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Collection;
import javax.ejb.EJB;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author Pierrick
 */
@WebServlet(name = "ServletCompteBancaire", urlPatterns = {"/ServletCompteBancaire"})
public class ServletCompteBancaire extends HttpServlet {

    @EJB
    private GestionnaireDeCompteBancaireLocal gestionnaireDeCompteBancaire;

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();

        String action = request.getParameter("action");
        String id = request.getParameter("id");

        String forwardTo = "";
        String message = "";

        Collection<CompteBancaire> c = null;
        Collection<OperationBancaire> c2 = null;

        Collection<Proprietaire> p = null;

        //Créer les comptes TEST
        if (action.equals("creerCompteBancaire")) {
            gestionnaireDeCompteBancaire.creerComptesTest();
            c = gestionnaireDeCompteBancaire.afficherTout();
            request.setAttribute("ListeDesComptes", c);
            RequestDispatcher dp = request.getRequestDispatcher("afficheurDeComptes.jsp");
            dp.forward(request, response);
        }

        if (action.equals("creerProprietaire")) {
            String nom = request.getParameter("nom");
            String prenom = request.getParameter("prenom");
            String adresse = request.getParameter("adresse");
            String telephone = request.getParameter("telephone");

            if (nom == null) {
                RequestDispatcher dp = request.getRequestDispatcher("creerProprietaire.jsp");
                dp.forward(request, response);
            } else {

                int idProprietaire = gestionnaireDeCompteBancaire.CreerProprietaire(nom, prenom, adresse, telephone).getId();

                request.setAttribute("proprietaire", gestionnaireDeCompteBancaire.getProprietaire(idProprietaire));
                request.setAttribute("listeDesComptes", gestionnaireDeCompteBancaire.getProprietaire(idProprietaire).getListeComptes());

                RequestDispatcher dp = request.getRequestDispatcher("afficheurUnProprietaire.jsp");
                dp.forward(request, response);
            }
        }

        //Créer un compte
        if (action.equals("creerCompte")) {
            int idProprietaire = Integer.parseInt(request.getParameter("id"));
            String nomProprietaire = gestionnaireDeCompteBancaire.getProprietaire(idProprietaire).getNom();
            String soldeString = request.getParameter("solde");

            //pour ouvrir un compte, le solde doit être supérieur à 100€
            if (soldeString == null) {
                request.setAttribute("id", idProprietaire);
                request.setAttribute("nom", nomProprietaire);
                RequestDispatcher dp = request.getRequestDispatcher("creerCompte.jsp");
                dp.forward(request, response);
            } else {
                int solde = Integer.parseInt(soldeString);
                int tauxInteret = Integer.parseInt(request.getParameter("tauxInteret"));

                Collection<OperationBancaire> colOpe = null;

                if (tauxInteret > 0) {
                    gestionnaireDeCompteBancaire.creerCompte(idProprietaire, solde, colOpe, tauxInteret);
                } else {
                    gestionnaireDeCompteBancaire.creerCompte(idProprietaire, solde, colOpe);
                }

                request.setAttribute("id", idProprietaire);
                action = "afficherUnProprietaire";

            }
        }

        if (action.equals("afficherProprietaires")) {
            p = gestionnaireDeCompteBancaire.afficherProprietaires();

            request.setAttribute("ListeDesProprietaires", p);
            RequestDispatcher dp = request.getRequestDispatcher("afficheurDeProprietaires.jsp");
            dp.forward(request, response);
        }

        if (action.equals("afficherUnProprietaire")) {
            int idProprietaire = Integer.parseInt(request.getParameter("id"));
            request.setAttribute("proprietaire", gestionnaireDeCompteBancaire.getProprietaire(idProprietaire));
            request.setAttribute("listeDesComptes", gestionnaireDeCompteBancaire.getProprietaire(idProprietaire).getListeComptes());

            Collection<CompteBancaire> col = gestionnaireDeCompteBancaire.getProprietaire(idProprietaire).getListeComptes();

            System.out.println("wazaaaaaaa");
            for (CompteBancaire i : col) {
                System.out.println(i.getSolde());
            }
            RequestDispatcher dp = request.getRequestDispatcher("afficheurUnProprietaire.jsp");
            dp.forward(request, response);
        }

        if (action.equals("afficherCompte")) {
            c = gestionnaireDeCompteBancaire.afficherTout();
            request.setAttribute("ListeDesComptes", c);
            RequestDispatcher dp = request.getRequestDispatcher("afficheurDeComptes.jsp");
            dp.forward(request, response);
        }

        if (action.equals("transfert")) {
            int id1 = Integer.parseInt(request.getParameter("idDonneur"));
            int id2 = Integer.parseInt(request.getParameter("idReceveur"));
            int montant = Integer.parseInt(request.getParameter("montant"));
            gestionnaireDeCompteBancaire.transfererArgent(id1, id2, montant);
            c = gestionnaireDeCompteBancaire.afficherTout();
            request.setAttribute("ListeDesComptes", c);
            RequestDispatcher dp = request.getRequestDispatcher("afficheurDeComptes.jsp");
            dp.forward(request, response);
        }

        if (action.equals("retourAccueil")) {
            RequestDispatcher dp = request.getRequestDispatcher("creerComptesTest.jsp");
            dp.forward(request, response);
        }

        if (action.equals("transfertCompte")) {
            c = gestionnaireDeCompteBancaire.afficherTout();
            request.setAttribute("ListeDesComptes", c);
            RequestDispatcher dp = request.getRequestDispatcher("transfertComptes.jsp");
            dp.forward(request, response);
        }

        if (action.equals("historiqueCompte")) {
            c2 = gestionnaireDeCompteBancaire.afficherOpe(Integer.parseInt(id));
            String nom = gestionnaireDeCompteBancaire.getCompte(Integer.parseInt(id)).getProprietaire().getNom();
            int idProprio = gestionnaireDeCompteBancaire.getCompte(Integer.parseInt(id)).getProprietaire().getId();
            request.setAttribute("ListeDesOpe", c2);
            request.setAttribute("id", id);
            request.setAttribute("nom", nom);
            request.setAttribute("idProprio", idProprio);
            RequestDispatcher dp = request.getRequestDispatcher("afficheHistoriqueCompte.jsp");
            dp.forward(request, response);
        }



    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
