<%--
    Document   : transfertComptes
    Created on : 7 oct. 2010, 13:15:19
    Author     : Pierrick
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" type="text/css" href="src_form/view.css" media="all">
        <script type="text/javascript" src="src_form/view.js"></script>
        <title>Transfert d'argent</title>
    </head>
    <body id="main_body" >

        <img id="top" src="src_form/top.png" alt="">
        <div id="form_container">

            <h1><a>Transférer de l'argent</a></h1>
            <form id="form_29254" class="appnitro"  method="post" name="transfert" action="ServletCompteBancaire?action=transfert">
                <div class="form_description">
                    <h2>Transférer de l'argent</h2>
                    <p>Effectuer un transfert d'un compte A vers un compte B</p>
                </div>
                <ul >

                    <li id="li_2" >
                        <label class="description" for="element_2">Compte à débiter </label>
                        <div>
                            <select class="element select medium" id="element_2" name="idDonneur">
                                <c:forEach var="c" items="${requestScope['ListeDesComptes']}">
                                    <option value="${c.id}">${c.id} - ${c.proprietaire.nom}</option>
                                </c:forEach>
                            </select>
                        </div>
                    </li>		<li id="li_3" >
                        <label class="description" for="element_3">Compte à créditer </label>
                        <div>
                            <select class="element select medium" id="element_3" name="idReceveur">
                                <c:forEach var="c" items="${requestScope['ListeDesComptes']}">
                                    <option value="${c.id}">${c.id} - ${c.proprietaire.nom}</option>
                                </c:forEach>

                            </select>
                        </div>
                    </li>		<li id="li_1" >
                        <label class="description" for="element_1">Montant </label>

                        <span>
                            <input id="element_1_1" name="montant" class="element text currency" size="10" value="" type="text" />
                            <label for="element_1_1">Euros</label>
                        </span>
                        <span class="symbol">&#8364;</span>

                    </li>

                    <li class="buttons">
                        <input type="hidden" name="form_id" value="29254" />
                        <input id="saveForm" class="button" type="submit" name="valider" value="Valider" />
                    </li>
                    <br />
                    <li>
                        <a href="ServletCompteBancaire?action=afficherCompte" class="basic">Retour aux comptes</a>
                    </li>
                </ul>
            </form>


            <div id="footer">
			Développé par Martino Pierrick et Polidori Grégoire<br />
                IUP MIAGE Nice Côte d'Azur
            </div>
        </div>
        <img id="bottom" src="src_form/bottom.png" alt="">
    </body>
</html>



