<%--
    Document   : AfficheHistoriqueCompte
    Created on : 7 oct. 2010, 17:20:49
    Author     : Pierrick
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" type="text/css" href="src_form/view.css" media="all">
        <script type="text/javascript" src="src_form/view.js"></script>
        <title>Opérations du compte ${id}</title>
    </head>
    <body id="main_body" >

        <img id="top" src="src_form/top.png" alt="">
        <div id="form_container">

            <h1><a>Opérations du compte ${id} appartenant à ${nom}</a></h1>

            <form id="form_transfert" class="appnitro"  method="post" name="opeCompte" action="ServletCompteBancaire?action=transfert">
                <div class="form_description">
                    <h2>Opérations du compte</h2>
                    <p>Liste de toutes les opérations du compte ${id} appartenant à ${nom}</p>
                </div>


                <ul >

                    <li id="li_2" >

                        <table border="0" width="600" cellpadding="2">
                            <thead>
                                <tr>
                                    <th>Date</th>
                                    <th>Description</th>
                                    <th>Montant</th>
                                </tr>
                            </thead>
                            <tbody>

                                <c:set var="total" value="0" scope="page" />

                                <c:forEach var="c" items="${requestScope['ListeDesOpe']}">
                                    <tr>
                                        <td align="center">${c.dateOperation}</td>
                                        <td align="right">${c.description} </td>
                                        <td align="right">${c.montant}</td>
                                    </tr>
                                    <c:set var="total" value='${total+c.montant}' scope="page" />
                                </c:forEach>

                                <tr>
                                    <td align="center"><b>TOTAL</b></td>
                                    <td></td>
                                    <td align="right"><b>${total}</b></td>
                                </tr>

                            </tbody>
                        </table>
                    </li>
                    <li>
                        <br />
                        <a href="ServletCompteBancaire?action=afficherUnProprietaire&id=${idProprio}" class="basic">Retour aux comptes de ${nom}</a><br />
                        <a href="ServletCompteBancaire?action=afficherCompte" class="basic">Retour à tous les comptes</a>
                    </li>
                </ul>
            </form>
            <div id="footer">
			Développé par Martino Pierrick et Polidori Grégoire<br />
                IUP MIAGE Nice Côte d'Azur
            </div>
        </div>
        <img id="bottom" src="src_form/bottom.png" alt="">

    </body>
</html>
