<%--
    Document   : afficheurDeComptes
    Created on : 23 sept. 2010, 11:56:33
    Author     : Pierrick
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <link rel="stylesheet" type="text/css" href="src_form/view.css" media="all">
        <script type="text/javascript" src="src_form/view.js"></script>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Liste des comptes</title>
    </head>
    <body id="main_body" >

        <img id="top" src="src_form/top.png" alt="">
        <div id="form_container">

            <h1><a>Liste des comptes</a></h1>

            <form id="form_transfert" class="appnitro"  method="post" name="affComptes" action="ServletCompteBancaire?action=transfert">
                <div class="form_description">
                    <h2>Liste des comptes</h2>
                    <p>Liste des comptes de tous les clients de la banque</p>
                </div>
                <c:set var="total" value="0"/>

                <ul >

                    <li id="li_2" >

                        <table border="0" width="100%" cellpadding="2">
                            <thead>
                                <tr>
                                    <th>Id compte</th>
                                    <th>Propriétaire</th>
                                    <th>Solde</th>
                                    <th>Détail des opérations</th>
                                </tr>
                            </thead>
                            <tbody>

                                <c:forEach var="c" items="${requestScope['ListeDesComptes']}">
                                    <tr>
                                        <td align="center">${c.id}</td>
                                        <td align="right"><a href="ServletCompteBancaire?action=afficherUnProprietaire&id=${c.proprietaire.id}" class="lienTable">${c.proprietaire.nom}</a></td>
                                        <td align="right">${c.solde} €</td>
                                        <td align="center"><a href="ServletCompteBancaire?action=historiqueCompte&id=${c.id}" class="lienTable">Détails du compte</a></td>
                                    </tr>

                                </c:forEach>

                            </tbody>
                        </table>
                    </li>
                    <li>
                        <br />
                        <a href="ServletCompteBancaire?action=retourAccueil" class="basic">Retour à l'accueil</a>
                    </li>
                </ul>
            </form>
            <div id="footer">
			Développé par Martino Pierrick et Polidori Grégoire<br />
                IUP MIAGE Nice Côte d'Azur
            </div>
        </div>
        <img id="bottom" src="src_form/bottom.png" alt="">
    </body>
</html>
