<%--
    Document   : afficheurDeComptes
    Created on : 23 sept. 2010, 11:56:33
    Author     : Pierrick
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" type="text/css" href="src_form/view.css" media="all">
        <script type="text/javascript" src="src_form/view.js"></script>
        <title>Liste des proprietaires</title>
    </head>
    <body id="main_body" >

        <img id="top" src="src_form/top.png" alt="">
        <div id="form_container">

            <h1><a>Liste des proprietaires</a></h1>

            <form id="form_transfert" class="appnitro"  method="post" name="transfert" action="ServletCompteBancaire?action=transfert">
                <div class="form_description">
                    <h2>Liste des propriétaires</h2>
                    <p>Liste tous les propriétaires de compte(s) au sein de la banque</p>
                </div>
                <c:set var="total" value="0"/>

                <ul >

                    <li id="li_2" >


                        <table border="0" width="600" cellpadding="2">
                            <thead>
                                <tr>
                                    <th>Id proprietaire</th>
                                    <th>Nom</th>
                                    <th>Prénom</th>
                                    <th>Adresse</th>
                                    <th>Téléphone</th>
                                </tr>
                            </thead>
                            <tbody>

                                <c:forEach var="c" items="${requestScope['ListeDesProprietaires']}">
                                    <tr>
                                        <td align="center">${c.id}</td>
                                        <td align="right"><a href="ServletCompteBancaire?action=afficherUnProprietaire&id=${c.id}" class="lienTable">${c.nom}</a></td>
                                        <td align="right">${c.prenom}</td>
                                        <td align="right">${c.adresse}</td>
                                        <td align="center">${c.telephone}</td>
                                    </tr>

                                </c:forEach>

                            </tbody>
                        </table>
                    </li>
                    <li>
                        <br />
                        <a href="ServletCompteBancaire?action=retourAccueil" class="basic">Retour à l'accueil</a>
                    </li>
                </ul>
            </form>
            <div id="footer">
			Développé par Martino Pierrick et Polidori Grégoire<br />
                IUP MIAGE Nice Côte d'Azur
            </div>
        </div>
        <img id="bottom" src="src_form/bottom.png" alt="">
    </body>
</html>
