<%--
    Document   : afficheurDeComptes
    Created on : 23 sept. 2010, 11:56:33
    Author     : Pierrick
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <link rel="stylesheet" type="text/css" href="src_form/view.css" media="all">
        <script type="text/javascript" src="src_form/view.js"></script>
        <title>Détails de ${proprietaire.nom}</title>
    </head>
    <body id="main_body" >
        <img id="top" src="src_form/top.png" alt="">
        <div id="form_container">
            <h1><a>Détails de ${proprietaire.nom}</a></h1>

            <form id="form_transfert" class="appnitro"  method="post" name="affUnPoprio" action="ServletCompteBancaire?action=transfert">
                <div class="form_description">
                    <h2>Détails de ${proprietaire.nom}</h2>
                    <p>Affiche les détails et les comptes de ${proprietaire.nom}</p>
                </div>

                <ul >

                    <li id="li_2" >
                        <table border="0" width="600" cellpadding="2">
                            <thead>
                                <tr>
                                    <th>Id proprietaire</th>
                                    <th>Nom</th>
                                    <th>Prénom</th>
                                    <th>Adresse</th>
                                    <th>Téléphone</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td align="center">${proprietaire.id}</td>
                                    <td align="center">${proprietaire.nom}</td>
                                    <td align="center">${proprietaire.prenom}</td>
                                    <td align="center">${proprietaire.adresse}</td>
                                    <td align="center">${proprietaire.telephone}</td>
                                </tr>

                            </tbody>
                        </table>
                        <br /><br />
                        <a href="ServletCompteBancaire?action=creerCompte&id=${proprietaire.id}" class="basic">Ajouter un compte supplémentaire</a>
                        <br /><br />

                        <table border="0" width="600" cellpadding="2">
                            <thead>
                                <tr>
                                    <th>Id compte</th>
                                    <th>Type</th>
                                    <th>Propriétaire</th>
                                    <th>Solde</th>
                                    <th>Taux</th>
                                    <th>Détail des opérations</th>
                                </tr>
                            </thead>
                            <tbody>

                                <c:forEach var="c" items="${requestScope['listeDesComptes']}">
                                    <tr>
                                        <td align="center">${c.id}</td>
                                        <td align="center"><c:catch var="e">
                                            <c:if test="${c.tauxInteret!=null}"></c:if>
                                        </c:catch>
                                                <c:if test="${e!=null}">Courant</c:if>
                                                <c:if test="${e==null}">Epargne</c:if>
                                    </td>
                                    <td align="center">${c.proprietaire.nom}</td>
                                    <td align="right">${c.solde} €</td>
                                    <td align="right">
                                                <c:if test="${e!=null}">-</c:if>
                                                <c:if test="${e==null}">${c.tauxInteret}</c:if></td>
                                    <td align="center"><a href="ServletCompteBancaire?action=historiqueCompte&id=${c.id}" class="lienTable">Détails du compte</a></td>
                                </tr>

                            </c:forEach>

                        </tbody>
                    </table>

                </li>
                <li>
                    <br />
                    <a href="ServletCompteBancaire?action=afficherCompte" class="basic">Retour aux comptes</a>
                </li>
            </ul>
        </form>
        <div id="footer">
			Développé par Martino Pierrick et Polidori Grégoire<br />
            IUP MIAGE Nice Côte d'Azur
        </div>
    </div>
    <img id="bottom" src="src_form/bottom.png" alt="">


</body>
</html>
